//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

enum KeyCodes
{
  NavKeyLeft  = 0x41,
  NavKeyRight = 0x53,
  NavKeyUp    = 0x57,
  NavKeyDown  = 0x5a
};

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner), s1( 0 ), s2( 0 )
{
  try
  {
    // Utworzenie obiektu dla pierwszej bitmapy
    s1 = new Graphics::TBitmap;
    // Zaladowanie bitmapy z pliku
    s1->LoadFromFile( "sprite1.bmp" );
    // Ustawienie transparentnosci
    s1->Transparent = true;
    // Kolorem transparentnym bedzie kolor pewnego piksela
    s1->TransparentMode = tmFixed;
    // Kolor transparentny pobierany z pierwszego piksela bitmapy
    s1->TransparentColor = s1->Canvas->Pixels[ 0 ][ 0 ];

    // Utworzenie obiektu dla pierwszej bitmapy
    s2 = new Graphics::TBitmap;
    // Zaladowanie bitmapy z pliku
    s2->LoadFromFile("sprite2.bmp");
    // Ustawienie transparentnosci
    s2->Transparent = true;
    // Kolorem transparentnym bedzie kolor pewnego piksela
    s2->TransparentMode = tmFixed;
    // Kolor transparentny pobierany z pierwszego piksela bitmapy
    s2->TransparentColor = s2->Canvas->Pixels[ 0 ][ 0 ];

    // Utworzenie obiektu dla tla
    bcgBmp = new Graphics::TBitmap;
    // Zaladowanie bitmapy z pliku
    bcgBmp->LoadFromFile( "grass.bmp" );
    bcgRect.Left = 0;
    bcgRect.Top = 0;
    bcgRect.Right = bcgBmp->Width;
    bcgRect.Top = bcgBmp->Height;

    // Utworzenie obiektu dla geby
    smileBmp = new Graphics::TBitmap;
    // Zaladowanie bitmapy z pliku
    smileBmp->LoadFromFile( "smile.bmp" );
    smileBmp->Transparent = true;
    // Kolorem transparentnym bedzie kolor pewnego piksela
    smileBmp->TransparentMode = tmFixed;
    // Kolor transparentny pobierany z pierwszego piksela bitmapy
    smileBmp->TransparentColor = smileBmp->Canvas->Pixels[ 0 ][ 0 ];

    // Utworzenie obiektu bufora
    workBmp = new Graphics::TBitmap;
    // Wstawienie do bufora tla
    workBmp->LoadFromFile( "grass.bmp" );

    InitObjects();
   }
  catch( ... )
  {
    ShowMessage( "Bd obsugi grafiki" );
  }
  randomize();
}

//---------------------------------------------------------------------------
void TForm1::InitObjects()
{
  // Ustalenie wielkosci obszaru "animacyjnego" tla
  bcgRect.Top = 0;
  bcgRect.Left = 0;
  bcgRect.Right =  ClientWidth;
  bcgRect.Bottom = Panel1->Top - 1;

  // Pierwszy sprite
  sprites[ 0 ].pos.x = 350;
  sprites[ 0 ].pos.y = 150;
  sprites[ 0 ].time = 0;
  sprites[ 0 ].sleepTime = 50;
  sprites[ 0 ].bitmap = s1;

  // Drugi sprite
  sprites[ 1 ].pos.x = 250;
  sprites[ 1 ].pos.y = 250;
  sprites[ 1 ].time = 0;
  sprites[ 1 ].sleepTime = 50;
  sprites[ 1 ].bitmap = s2;

  smilePos.x =  50;
  smilePos.y =  50;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  // Strt wszystkiego
  Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  // Oryginalny obraz tla do bufora
  workBmp->Canvas->CopyRect( bcgRect, bcgBmp->Canvas, bcgRect );

  // Narysowanie spritow, o ile przyszedl czas na zmian pozycji, wczesniej
  // wylosowanie nowej pozycji
  for( int i = 0; i < NumOfSprites; ++i )
  {
    if( --sprites[ i ].time <= 0 )
    {
      sprites[ i ].pos.x += random( 10 ) * ( random( 3 ) -  1 );
      sprites[ i ].pos.y += random( 10 ) * ( random( 3 ) -  1 );
      sprites[ i ].time = sprites[ i ].sleepTime;
    }
    // Rysowanie bitmapy w buforze
    workBmp->Canvas->Draw( sprites[i].pos.x, sprites[i].pos.y, sprites[i].bitmap );
  }

  // Narysowanie geby w buforze
  workBmp->Canvas->Draw( smilePos.x, smilePos.y, smileBmp );
  // Przekopiowanie bufora na plotno formy
  Canvas->CopyRect( bcgRect, workBmp->Canvas, bcgRect );
  // Wylosowanie nowej pozycji geby
  smilePos.x += random( 2 ) * ( random( 3 ) -  1 );
  smilePos.y += random( 2 ) * ( random( 3 ) -  1 );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  if( s1 != 0 )
    delete s1;
  if( s2 != 0 )
    delete s2;
  if( bcgBmp != 0 )
    delete bcgBmp;
  if( smileBmp != 0 )
    delete smileBmp;
  if( workBmp != 0 )
    delete workBmp;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  // Wstrzymanie timera == wstrzymanie animacji
  Timer1->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
   // Jezeli klikniecie w obrebie panela dolnego, to nie robimy nic
   if( X >= Panel1->Left && X < Panel1->Width
       && Y >= Panel1->Top && Y < Panel1->Height  )
     return;
   else
   {
      // Szukamy obiektu, ktory zostal klikniety
      if( X >= smilePos.x && X < smilePos.x + smileBmp->Width
          && Y >= smilePos.y && Y < smilePos.y + smileBmp->Height )
      {
         Timer1->Enabled = false;
         Application->MessageBox( "Daryl", "Info" );
         Timer1->Enabled = true;
      }
      for( int i = 0; i < NumOfSprites; ++i )
      {
        if( X >= sprites[ i ].pos.x
            && X < sprites[ i ].pos.x + sprites[ i ].bitmap->Width
            && Y >= sprites[ i ].pos.y
            && Y < sprites[ i ].pos.y + sprites[ i ].bitmap->Height )
          {
            Timer1->Enabled = false;
            AnsiString s( "Zombi nr: " );
            s += IntToStr( i + 1 );
            Application->MessageBox( s.c_str(), "Info" );
            Timer1->Enabled = true;
          }
       }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
   // Przesuwanie geby
   switch( Key )
   {
     case NavKeyLeft:  smilePos.x -= 5;
                       break;
     case NavKeyRight: smilePos.x += 5;
                       break;
     case NavKeyUp:    smilePos.y -= 5;
                       break;
     case NavKeyDown:  smilePos.y += 5;
                       break;
   }
}
//---------------------------------------------------------------------------

